#!/usr/pkg/bin/perl

package previews;

use CGI;
#use CGI::Carp qw( fatalsToBrowser );
use strict;

$ENV{PATH} .= ':/usr/pkg/bin';

$|=1;	 # turn off buffering for smoother, more interesting output.

my $query = new CGI;
print $query->header;
print $query->start_html;

my $thumbs = ".thumbs"; # subdirectory for thumbnails
my $lowres = ".lowres"; # subdirectory for lowres previews

print "<h1>Photo Gallery Maintenence</h1>\n";
print "<p>Please wait, running maintenance...</p>\n";
print "<pre>";

processDirectories();

print "</pre>\n";
print "<p><a href=\"index.cgi\">Return to gallery</a></p>";
print $query->end_html;

exit;

sub makeDirs($) {
  my $baseDir = shift;
  my $lowresDir = $baseDir."/".$lowres;
  my $thumbsDir = $baseDir."/".$thumbs;
  print "lowres directory: $lowresDir	thumbs directory: $thumbsDir\n";
  
  if (! -d $lowresDir) {
	print "creating missing lowres directory: $lowresDir\n";
	mkdir $lowresDir;
  }
  if (! -d $thumbsDir) {
	print "creating missing thumbnails directory: $thumbsDir\n";
	mkdir $thumbsDir;
  }
}

sub cleanOrphans($) {
	my $dir=shift;
	my $directory;
	foreach $directory ("$dir/$thumbs", "$dir/$lowres") {
	# check dir to see if there are stray files
	print "removing orphans from $directory directory\n";
	opendir DIR,"$directory" or die "can't open $directory directory: $!\n";
	my @files= readdir DIR;
	closedir DIR;
	my $file;
	foreach $file ( @files ) {
	# does this file not exist as a hires version
	if ($file !~ /\.orig$/) {
		if(!-r "$dir/$file") {
			print "deleting orphan file: $directory/$file\n";
			unlink "$directory/$file";
		}
	}
  }
  }
}
		 
sub makeThumbnails($) {
	my $dir = shift;
print "creating previews and thumbnails for $dir\n";
opendir DIR, $dir;
my @images = grep { /.[jJ][pP][eE]?[gG]$/ } readdir DIR;
closedir DIR;

my $image;
foreach $image ( @images ) {
  if (!-r "$dir/$lowres/$image") {
	print "creating lowres image for $dir/$image\n";
	system "djpeg '$dir/$image' | pnmscale -pixels 248832 | cjpeg -progressive > '$dir/$lowres/$image'";
  }
  if (!-r "$dir/$thumbs/$image") {
	print "creating thumbnail image for $dir/$image from lowres preview\n";
	system "djpeg '$dir/$lowres/$image' | pnmscale -pixels 10800 | cjpeg -progressive > '$dir/$thumbs/$image'";
  }
}

if ( -f "$dir/.rotation" ) {
  my $rotate;
  print "doing rotations based on $dir/.rotation\n";
  open ROTATE, "$dir/.rotation";
  while (defined ($rotate = <ROTATE>)) {
	chomp $rotate;
	my ($file,$degrees) = split(/ /,$rotate);
	if (! -f "$dir/$thumbs/${file}.orig" ) {
	  print "rotating thumbnail $dir/$file $degrees degrees.\n";
	  rename "$dir/$thumbs/$file", "$dir/$thumbs/${file}.orig";
	  system("jpegtran -rotate $degrees '$dir/$thumbs/${file}.orig' > '$dir/$thumbs/$file'");
	}
	if (! -f "$dir/$lowres/${file}.orig" ) {
	  print "rotating lowres $dir/$file $degrees degrees.\n";
	  rename "$dir/$lowres/$file", "$dir/$lowres/${file}.orig";
	  system("jpegtran -rotate $degrees '$dir/$lowres/${file}.orig' > '$dir/$lowres/$file'");
	}
  }
}

sub processDirectories() {
	opendir DIR,"." or die "can't open current directory: $!\n";
	my @files= readdir DIR;
	my $file;
	foreach $file (@files) {
		if ($file ne '.' and $file ne '..' and -d $file) {
			print "\n\ndirectory $file\n";
			makeDirs($file);
			cleanOrphans($file);
			makeThumbnails($file);
			print "done processing directory $file\n";
		}
	}
}


}
